PetBattle = select(2, ...)
local L = PetBattle.L

function PetBattle:OnInitialize()
	self.db = PetBattleSummaryDB or {}

	self:RegisterEvent("PET_BATTLE_OPENING_DONE")
	self:RegisterEvent("PET_BATTLE_OVER")
end

function PetBattle:PET_BATTLE_OPENING_DONE()

end

function PetBattle:PET_BATTLE_OVER()

end


-- UI
local function OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
	GameTooltip:SetHyperlink(self.link)
end

local function OnLeave(self)
	GameTooltip:Hide()
end

function PetBattle:CreateUI()
	if( self.frame ) then return end
	
	-- Container frame
	self.frame = CreateFrame("Frame", nil, UIParent)
	self.frame:SetWidth(300)
	self.frame:SetHeight(300)
	self.frame:SetMovable(true)
	self.frame:EnableMouse(true)
	self.frame:SetClampedToScreen(true)
	
	self.frame:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
		tile = true,
		tileSize = 32,
		edgeSize = 32,
		insets = {left = 10, right = 10, top = 10, bottom = 10},
	})
	
	self.frame:SetBackdropColor(0, 0, 0, 1)

	-- Create the title/movy thing
	local texture = self.frame:CreateTexture(nil, "ARTWORK")
	texture:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	texture:SetPoint("TOP", 0, 13)
	texture:SetWidth(240)
	texture:SetHeight(60)
	
	local title = CreateFrame("Button", nil, self.frame)
	title:SetPoint("TOP", 0, 4)
	title:SetText(L["Battle Summary"])
	title:SetPushedTextOffset(0, 0)
	title:SetNormalFontObject(GameFontNormal)
	title:SetHeight(20)
	title:SetWidth(200)

	title:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
		GameTooltip:SetText(L["Alt + Left Click to drag"])
	end)
	title:SetScript("OnLeave", function() GameTooltip:Hide() end)

	title:RegisterForDrag("LeftButton")
	title:SetScript("OnDragStart", function(self)
		if( IsAltKeyDown() ) then
			self.isMoving = true
			PetBattle.frame:StartMoving()
		end
	end)
	
	title:SetScript("OnDragStop", function(self)
		if( self.isMoving ) then
			self.isMoving = nil
			PetBattle.frame:StopMovingOrSizing()

			local parent = self:GetParent()
			local scale = parent:GetEffectiveScale()
			PetBattle.db.position = { x = parent:GetLeft() * scale, y = parent:GetTop() * scale }
		end
	end)
	
	if( self.db.position ) then
		local scale = self.frame:GetEffectiveScale()
		self.frame:ClearAllPoints()
		self.frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", self.db.position.x / scale, self.db.position.y / scale)
	else
		self.frame:SetPoint("CENTER")
	end

	self.frame:Show()
end

local frame = CreateFrame("Frame")
frame:RegisterEvent("ADDON_LOADED")
frame:SetScript("OnEvent", function(self, event, addon)
	if( addon == "PetBattleSummary" ) then
		frame:UnregisterEvent("ADDON_LOADED")
		frame:SetScript("OnEvent", function(self, event, ...)
			PetBattle[event](PetBattle, event, ...)
		end)

		PetBattle:OnInitialize()
	end
end)

function PetBattle:RegisterEvent(event) frame:RegisterEvent(event) end
function PetBattle:UnregisterEvent(event) frame:UnregisterEvent(event) end

